#ifndef __MTLWEB_H__
#define __MTLWEB_H__

// MTL Version 1.01
// Copyright (C) 2000 MB<mb2@geocities.co.jp>
// All rights unreserved.
//
// This file is a part of Mb Template Library.
// The code and information is *NOT* provided "as-is" without
// warranty of any kind, either expressed or implied.
//
// Last updated: July 05, 2000

#pragma once

#ifndef __MTLMISC_H__
	#error mtlweb.h requires mtlmisc.h to be included first
#endif

#ifndef _WININET_
	#error mtlweb.h requires wininet.h to be included first
#endif

#ifndef _INC_SHLWAPI
	#error mtlweb.h requires shlwapi.h to be included first
#endif

#ifndef __INTSHCUT_H__
	#error mtlweb.h requires intshcut.h to be included first
#endif

#include <algorithm>
#include <list>
#include <IntShCut.h>

namespace MTL
{

inline bool MtlGetFavoritesFolder(CString& rString)
{
	CRegKey rk;
	LONG lRet = rk.Open(HKEY_CURRENT_USER,
		_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders"));
	if(lRet != ERROR_SUCCESS)
		return false;

	TCHAR szRetString[MAX_PATH];
	DWORD dwCount = MAX_PATH * sizeof(TCHAR);
	lRet = rk.QueryValue(szRetString, _T("Favorites"), &dwCount);
	if(lRet != ERROR_SUCCESS) {
		rk.Close();
		lRet = rk.Open(HKEY_CURRENT_USER,
			_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders"));
		if (lRet != ERROR_SUCCESS)
			return false;
		lRet = rk.QueryValue(szRetString, _T("Favorites"), &dwCount);
		if (lRet != ERROR_SUCCESS)
			return false;
	}
	rk.Close();

	TCHAR szRetString2[MAX_PATH];
	::ExpandEnvironmentStrings(szRetString, szRetString2, MAX_PATH);
	rString = szRetString2;
	ATLTRACE2(atlTraceUser, 4, _T("MTL: MtlGetFavoritesFolder : %s\n"), szRetString2);
	return true;
}

inline bool MtlGetHistoryFolder(CString& rString)
{
	CRegKey rk;
	LONG lRet = rk.Open(HKEY_CURRENT_USER,
		_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\User Shell Folders"));
	if(lRet != ERROR_SUCCESS)
		return false;

	TCHAR szRetString[MAX_PATH];
	DWORD dwCount = MAX_PATH * sizeof(TCHAR);
	lRet = rk.QueryValue(szRetString, _T("History"), &dwCount);
	if(lRet != ERROR_SUCCESS) {
		rk.Close();
		lRet = rk.Open(HKEY_CURRENT_USER,
			_T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders"));
		if (lRet != ERROR_SUCCESS)
			return false;
		lRet = rk.QueryValue(szRetString, _T("History"), &dwCount);
		if (lRet != ERROR_SUCCESS)
			return false;
	}
	rk.Close();

	TCHAR szRetString2[MAX_PATH];
	::ExpandEnvironmentStrings(szRetString, szRetString2, MAX_PATH);
	rString = szRetString2;
	ATLTRACE2(atlTraceUser, 4, _T("MTL: MtlGetFavoritesFolder : %s\n"), szRetString2);
	return true;
}

inline bool MtlGetFavoriteLinksFolder(CString& rString)
{// inspired by DOGSTORE
	if (!MtlGetFavoritesFolder(rString))
		return false;

	MtlMakeSureTrailingBackSlash(rString);

	CRegKey rk;
	LONG lRet = rk.Open(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Internet Explorer\\Toolbar"));
	if (lRet == ERROR_SUCCESS) {
		TCHAR szName[MAX_PATH];
		DWORD dwCount = MAX_PATH * sizeof(TCHAR);
		lRet = rk.QueryValue(szName, _T("LinksFolderName"), &dwCount);
		if (lRet == ERROR_SUCCESS) {
			TCHAR szName2[MAX_PATH];
			::ExpandEnvironmentStrings(szName, szName2, MAX_PATH);
			rString += szName2;
			MtlMakeSureTrailingBackSlash(rString);
			return true;
		}
	}

  #if 1 //+++ vista΍
	CString str ( rString );
	str += _T("N\\");
	if (::GetFileAttributes(str) != 0xFFFFFFFF)
		rString = str;
	else
		rString += _T("links\\");
  #else
	rString += _T("N\\");
  #endif

	return false;
}

bool MtlCreateInternetShortcutFile(const CString& strFileName, const CString& strUrl)
{// Thanks to <http://www.nt.sakura.ne.jp/~miwaki/>
	CComPtr<IUniformResourceLocator> spUrl;
	HRESULT hr = ::CoCreateInstance(CLSID_InternetShortcut, NULL,
				CLSCTX_ALL, IID_IUniformResourceLocator, (void**)&spUrl);
	if (FAILED(hr))
		return false;

	CComPtr<IPersistFile> spPf;
	hr = spUrl->QueryInterface(IID_IPersistFile, (void**)&spPf);
	if (FAILED(hr))
		return false;

	hr = spUrl->SetURL(strUrl, 0);
	if (FAILED(hr))
		return false;

	USES_CONVERSION;
	hr = spPf->Save(T2COLE((LPCTSTR)strFileName), TRUE);
	if (FAILED(hr))
		return false;

	return true;
}


// Note. If the third parameter is "CString strPath", it rarely crash. why?
inline void MtlOrganizeFavorite(HWND hWnd, bool bOldShell = false, const CString& strPath_ = _T(""))
{
/*	Wrong code: dialog can't handle mouse message
	CComPtr<IShellUIHelper> spShell;
	HRESULT hr = spShell.CoCreateInstance(CLSID_ShellUIHelper, NULL);
	if (SUCCEEDED(hr)) {
	//	CComVariant v1, v2;
	//	CComBSTR bstr(OLESTR("OrganizeFavorites"));
	//	HRESULT hr = spShell->ShowBrowserUI(bstr, &v1, NULL);//&v2);
		CComVariant v1(OLESTR("OrganizeFavorites"));
		CComDispatchDriver driver(spShell);
		hr = driver.Invoke1(0x0000000d, &v1, NULL);
		if (FAILED(hr)) {
			CString strPath;
			if (MBtlGetFavoriteDirectory(strPath)) {
				::ShellExecute(0, "open", "explorer.exe", strPath, ".", SW_SHOW);
			}
		}
	}
*/
	// get favorite path
	CString strPath(strPath_);
	if (strPath.IsEmpty())
		MtlGetFavoritesFolder(strPath);

	if (bOldShell) {
		// easy way
		::ShellExecute(NULL, NULL, strPath, NULL, NULL, SW_SHOWNORMAL);
		return;
	}

	HINSTANCE hLib = ::LoadLibrary(_T("shdocvw.dll"));
	if (hLib) {
		typedef UINT (CALLBACK* LPFNORGFAV)(HWND, LPTSTR);
		LPFNORGFAV lpfnDoOrganizeFavDlg = (LPFNORGFAV)::GetProcAddress(hLib, "DoOrganizeFavDlg");
		if (lpfnDoOrganizeFavDlg) {
			TCHAR szPath[MAX_PATH];
			::lstrcpy(szPath, strPath);
			(*lpfnDoOrganizeFavDlg)(hWnd, szPath);
		}
		::FreeLibrary(hLib);
		// a following fails if old shell (not support ::SHGetSpecialFolderPath)
		// TCHAR szPath[MAX_PATH];
		// HRESULT hr = ::SHGetSpecialFolderPath(m_hWnd, szPath, CSIDL_FAVORITES, TRUE);
		// if (SUCCEEDED(hr)) {
		//	lpfnDoOrganizeFavDlg(m_hWnd, strPath);
		// }

		// We must rebuild the menu each time because
		// DoOrganizeFavDlg doesn't indicate if nothing
		// was changed.
		// BeginWaitCursor();
		// BuildFavoritesMenu();   // Rebuild all the favorites links
		// EndWaitCursor();
	}
	else {
		// easy way
		::ShellExecute(NULL, NULL, strPath, NULL, NULL, SW_SHOWNORMAL);
	}
}

inline bool __MtlAddFavoriteOldShell(const CString& strUrl, const CString& strName_, const CString& strFavDir)
{
	// easy way for old shell users
	static const TCHAR szFilter[] = _T("URLt@C(*.url)\0*.url\0\0");
	TCHAR szOldPath[MAX_PATH];// save current directory
	::GetCurrentDirectory(MAX_PATH, szOldPath);

	::SetCurrentDirectory(strFavDir);

	CString strName(strName_);
	MtlValidateFileName(strName);

	CFileDialog fileDlg(FALSE, _T("url"), strName,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);
	fileDlg.m_ofn.lpstrInitialDir = strFavDir;
	fileDlg.m_ofn.lpstrTitle = _T("Cɓɒǉ");

	if (fileDlg.DoModal() == IDOK) {
		CString strFile(fileDlg.m_szFileName);
		if (!MtlIsExt(strFile, _T(".url")))
			strFile += _T(".url");

		::WritePrivateProfileString(_T("InternetShortcut"), _T("URL"),
					 strUrl, strFile);
	}
	::SetCurrentDirectory(szOldPath);

	return true;
}

inline bool _MtlAddFavoriteNewShell(const CString& strUrl, const CString& strName)
{
	CComPtr<IShellUIHelper> spShell;
	HRESULT hr = spShell.CoCreateInstance(CLSID_ShellUIHelper);
	if (FAILED(hr))
		return false;

	CComBSTR bstrName(strName);
	CComBSTR bstrUrl(strUrl);
	CComVariant vt(bstrName);
	hr = spShell->AddFavorite(bstrUrl, &vt);
	if (FAILED(hr))
		return false;

	return true;
}

inline bool _MtlAddFavoriteModalSucks(const CString& strUrl, const CString& strName_,
									  const CString& strFavPath, HWND hWnd)
{
	CString strName(strName_);
	MtlValidateFileName(strName);

	bool bResult = false;
//	NOTE. Some buttons can't be validate. I'm fed up with IE.]
	typedef BOOL (CALLBACK* LPFNADDFAV)(HWND, LPTSTR, UINT, LPTSTR, UINT, LPITEMIDLIST);
	HMODULE hMod = (HMODULE)::LoadLibrary(_T("shdocvw.dll"));
	if (hMod) {
		LPFNADDFAV lpfnDoAddToFavDlg = (LPFNADDFAV)::GetProcAddress(hMod, "DoAddToFavDlg");
		if (lpfnDoAddToFavDlg) {
			int nLen = strName.GetLength();
			LPTSTR szName = (LPTSTR)_alloca((nLen+1)*sizeof(TCHAR));
			::lstrcpy(szName, strName);

			TCHAR szPath[MAX_PATH];
			CItemIDList idlFavPath = strFavPath;
			BOOL bOK = lpfnDoAddToFavDlg(hWnd,
				szPath, _countof(szPath),
				szName, nLen,
				idlFavPath);

			if (bOK)
				MtlCreateInternetShortcutFile(szPath, strUrl);

			bResult = true;
		}

		FreeLibrary(hMod);
	}

	return bResult;
}

inline bool MtlAddFavorite(const CString& strUrl, const CString& strName, bool bOldShell = false,
						   const CString& strFavDir_ = _T(""), HWND hWnd = NULL)
{// how complex...
	CString strStdFavDir;
	if (!MtlGetFavoritesFolder(strStdFavDir))
		return false;

	CString strFavDir(strFavDir_);
	if (strFavDir.IsEmpty()) {
		strFavDir = strStdFavDir;
	}

	if (bOldShell) {
		return __MtlAddFavoriteOldShell(strUrl, strName, strFavDir);
	}

	bool bStdFavDir = (strStdFavDir == strFavDir);

	if (bStdFavDir) {
		if (!_MtlAddFavoriteNewShell(strUrl, strName))
			return __MtlAddFavoriteOldShell(strUrl, strName, strFavDir);
	}
	else {
		if (!_MtlAddFavoriteModalSucks(strUrl, strName, strFavDir, hWnd))
			return __MtlAddFavoriteOldShell(strUrl, strName, strFavDir);
	}

	return false;
}

#pragma comment( lib, "wininet" )
// cf.MSDN "Offline Browsing"
// Bug: Even if an user is working-Offline before your application runs,
//		this function always returns FALSE.
inline bool MtlIsGlobalOffline()
{
	DWORD dwState = 0, dwSize = sizeof(DWORD);
	bool bRet = false;

	if(::InternetQueryOption(NULL, INTERNET_OPTION_CONNECTED_STATE, &dwState, &dwSize)) {
		if(dwState & INTERNET_STATE_DISCONNECTED_BY_USER)
			bRet = true;
	}

	return bRet;
}

// cf.MSDN "Offline Browsing"
inline void MtlSetGlobalOffline(bool bGoOffline)
{
	if (MtlIsGlobalOffline() == bGoOffline)
		return;

	INTERNET_CONNECTED_INFO ci;
	memset(&ci, 0, sizeof(ci));
	if(bGoOffline) {
		ci.dwConnectedState = INTERNET_STATE_DISCONNECTED_BY_USER;
		ci.dwFlags = ISO_FORCE_DISCONNECTED;
	}
	else {
		ci.dwConnectedState = INTERNET_STATE_CONNECTED;
	}

	::InternetSetOption(NULL, INTERNET_OPTION_CONNECTED_STATE, &ci, sizeof(ci));
}

#if (_WIN32_IE >= 0x0500)
inline bool MtlAutoComplete(HWND hWnd)
{
	bool bRet = false;
	HINSTANCE hLib = ::LoadLibrary(_T("shlwapi.dll"));
	if (hLib) {
		typedef HRESULT (CALLBACK *LPFNSHAUTOCOMPLETE)(HWND hWnd, DWORD dw);
		LPFNSHAUTOCOMPLETE lpfnSHAutoComplete = (LPFNSHAUTOCOMPLETE)::GetProcAddress(hLib, "SHAutoComplete");
		if (lpfnSHAutoComplete) {
			HRESULT hr = (*lpfnSHAutoComplete)(hWnd, SHACF_FILESYSTEM | SHACF_URLALL | SHACF_USETAB);
			if (SUCCEEDED(hr))
				bRet = true;
		}
		::FreeLibrary(hLib);
	}

	return bRet;
}
#endif

//+++ inline MtlShowInternetOptions()
inline void MtlShowInternetOptions()
{// this is modeless
	::ShellExecute(0, _T("open"), _T("control.exe"), _T("inetcpl.cpl"), _T("."), SW_SHOW);
}

inline bool MtlCreateShortCutFile(const CString& strFile, const CString& strTarget,
					   const CString& strDescription = _T(""), const CString& strArgs = _T(""),
					   const CString& strWorkingDir = _T(""), const CString& strIconPath = _T(""),
					   int iIcon = 0, int iShowCmd = SW_SHOWNORMAL) // EBhEX^C
{// Thanks to <http://www.nt.sakura.ne.jp/~miwaki/>
	if (MtlIsExt(strTarget, _T(".url")) || MtlIsExt(strTarget, _T(".lnk"))) {
		// if target is .lnk or .url, just copy!!
		CString strFolder = MtlGetDirectoryPath(strFile, true);
		CString strTarget_ = strTarget;
		CSimpleArray<CString> arrFiles; arrFiles.Add(strTarget_);
		return MtlCopyFile(strFolder, arrFiles);
	}

	CComPtr<IShellLink> spLink;
	HRESULT hr = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_ALL, IID_IShellLink, (void**)&spLink);
	if (FAILED(hr))
		return false;

	CComPtr<IPersistFile> spFile;
	hr = spLink->QueryInterface(IID_IPersistFile, (void**)&spFile);
	if (FAILED(hr))
		return false;


	spLink->SetPath(strTarget);

	if (!strDescription.IsEmpty())
		spLink->SetDescription(strDescription);
	if (!strArgs.IsEmpty())
		spLink->SetArguments(strArgs);
	if (!strWorkingDir.IsEmpty())
		spLink->SetWorkingDirectory(strWorkingDir);
	if (!strIconPath.IsEmpty())
		spLink->SetIconLocation(strIconPath, iIcon);

	spLink->SetShowCmd(iShowCmd);

	USES_CONVERSION;
	hr = spFile->Save(T2COLE((LPCTSTR)strFile), TRUE);
	if (FAILED(hr))
		return false;

	return true;
}

inline bool MtlParseIntenetShortcutFile(CString& strFilePath)
{
	CString strExt = strFilePath.Right(4);

	if (strExt.CompareNoCase(_T(".url")) != 0)
		return false;

	TCHAR szUrl[INTERNET_MAX_PATH_LENGTH];
	::GetPrivateProfileString(_T("InternetShortcut"), _T("URL"),
		  _T(""), szUrl, INTERNET_MAX_PATH_LENGTH, strFilePath);

	CString strUrl(szUrl);
	if (strUrl.IsEmpty())
		return false;

	strFilePath = strUrl;
	return true;

}

inline CString MtlGetInternetShortcutUrl(const CString& strFile)
{
	if (!MtlIsExt(strFile, _T(".url"))) // to avoid the crash, fixed by DOGSTORE
		return CString();

	CString strResult;

	CComPtr<IUniformResourceLocator> spUrl;
	HRESULT hr = CoCreateInstance(CLSID_InternetShortcut, NULL, CLSCTX_INPROC_SERVER,
								 IID_IUniformResourceLocator, (void**)&spUrl);
	if (FAILED(hr))
		return strResult;

	CComPtr<IPersistFile> spFile;
	hr = spUrl->QueryInterface(IID_IPersistFile, (void**)&spFile);
	if (FAILED(hr))
		return strResult;

	// Load the Internet Shortcut from persistent storage.
	USES_CONVERSION;
	hr = spFile->Load(T2COLE(strFile), STGM_READ);
	if (FAILED(hr))
		return strResult;

	LPTSTR pszUrl;
	hr = spUrl->GetURL(&pszUrl);
	if (SUCCEEDED(hr)) {
		strResult = pszUrl;
		::CoTaskMemFree(pszUrl);
	}

	return strResult;
}

bool MtlPreOpenFile(CString& strPath, const CString& strArg = CString())
{
	ATLTRACE(_T("MtlPreOpenFile(%s)\n"), strPath.Left(100));

	if (MtlIsExt(strPath, _T(".exe"))) {
		::ShellExecute(NULL, _T("open"), strPath, strArg, NULL, SW_SHOWNORMAL);
		return true;// handled
	}

	if (!MtlIsExt(strPath, _T(".lnk")))
		return false;// not handled

	CComPtr<IShellLink> spShellLink;
	// Create IShellLink Objec
	HRESULT hr = ::CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_ALL, IID_IShellLink, (void **)&spShellLink);
	if (FAILED(hr))
		return false;

	CComQIPtr<IPersistFile> spPersistFile(spShellLink);
	if (spPersistFile) {
		// load shortcut
		USES_CONVERSION;
		hr = spPersistFile->Load(T2COLE(strPath), STGM_READ);
		if (SUCCEEDED(hr)) {
			// get link
			TCHAR szFilePath[MAX_PATH];
			WIN32_FIND_DATA wfd;
			hr = spShellLink->GetPath(szFilePath, MAX_PATH, &wfd, SLGP_UNCPRIORITY);
			if (FAILED(hr))
				return false;

			if (!MtlIsExt(szFilePath, _T(".exe"))) {
				strPath = szFilePath;
				return false;
			}

			TCHAR szCmdLine[2048]; szCmdLine[0] = _T('\0');
			hr = spShellLink->GetArguments(szCmdLine, 2048);

			if (!strArg.IsEmpty())
				::lstrcpyn(szCmdLine, strArg, 2048);

			int nShowCmd = SW_SHOWNORMAL;
			hr = spShellLink->GetShowCmd(&nShowCmd);

			TCHAR szDirPath[MAX_PATH]; szDirPath[0] = _T('\0');
			hr = spShellLink->GetWorkingDirectory(szDirPath, 2048);

			::ShellExecute(NULL, _T("open"), szFilePath, szCmdLine, szDirPath, nShowCmd);
			return true;// handled
		}
	}

	return false;
}

// Undocumented command ids
static const CLSID CGID_IWebBrowser = {0xED016940L,0xBD5B,0x11cf,0xBA, 0x4E,0x00,0xC0,0x4F,0xD7,0x08,0x16};
#define HTMLID_FIND 1
#define HTMLID_VIEWSOURCE 2
#define HTMLID_OPTIONS 3

template <class T>
class CWebBrowserCommandHandler
{
public:
// Message map and handlers
	BEGIN_MSG_MAP(CWebBrowserCommandHandler)
		COMMAND_ID_HANDLER_EX(ID_FILE_SAVE_AS, OnFileSaveAs)
		COMMAND_ID_HANDLER_EX(ID_FILE_PAGE_SETUP, OnFilePageSetup)
		COMMAND_ID_HANDLER_EX(ID_FILE_PRINT, OnFilePrint)
		COMMAND_ID_HANDLER_EX(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview) // suggested by DOGSTORE, thanks
		COMMAND_ID_HANDLER_EX(ID_FILE_PROPERTIES, OnFileProperties)
		COMMAND_ID_HANDLER_EX(ID_EDIT_CUT, OnEditCut)
		COMMAND_ID_HANDLER_EX(ID_EDIT_COPY, OnEditCopy)
		COMMAND_ID_HANDLER_EX(ID_EDIT_PASTE, OnEditPaste)
		COMMAND_ID_HANDLER_EX(ID_EDIT_FIND, OnEditFind)
		COMMAND_ID_HANDLER_EX(ID_EDIT_SELECT_ALL, OnEditSelectAll)
		COMMAND_ID_HANDLER_EX(ID_VIEW_BACK, OnViewBack)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FORWARD, OnViewForward)
		COMMAND_ID_HANDLER_EX(ID_VIEW_REFRESH, OnViewRefresh)
		COMMAND_ID_HANDLER_EX(ID_VIEW_STOP, OnViewStop)
		COMMAND_ID_HANDLER_EX(ID_VIEW_HOME, OnViewHome)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_LARGEST, OnViewFontLargest)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_LARGER, OnViewFontLarger)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_MEDIUM, OnViewFontMedium)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_SMALLER, OnViewFontSmaller)
		COMMAND_ID_HANDLER_EX(ID_VIEW_FONT_SMALLEST, OnViewFontSmallest)
		COMMAND_ID_HANDLER_EX(ID_VIEW_SOURCE, OnViewSource)
		COMMAND_ID_HANDLER_EX(ID_VIEW_OPTION, OnViewOption)
	END_MSG_MAP()

	void OnFileSaveAs(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_SAVEAS, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnFilePageSetup(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PAGESETUP, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnFilePrint(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnFilePrintPreview(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnFileProperties(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PROPERTIES, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditCut(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_CUT, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditCopy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_COPY, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditPaste(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_PASTE, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		CComQIPtr<IOleCommandTarget> spCmdTarget = pT->m_spBrowser;
		spCmdTarget->Exec(&CGID_IWebBrowser, HTMLID_FIND, 0, NULL, NULL);
		// this is just file search
		//	m_spBrowser->ExecWB(OLECMDID_FIND, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}
	void OnEditSelectAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_SELECTALL, OLECMDEXECOPT_DODEFAULT, NULL, NULL);
	}

	void OnViewBack(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->GoBack();
	}
	void OnViewForward(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->GoForward();
	}
	void OnViewRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->Refresh();
	}
	void OnViewStop(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->Stop();
	}
	void OnViewHome(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->GoHome();
	}
	void OnViewOption(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		CComQIPtr<IOleCommandTarget> spCmdTarget = pT->m_spBrowser;
		spCmdTarget->Exec(&CGID_IWebBrowser, HTMLID_OPTIONS, 0, NULL, NULL);
		// this is modeless
		// ::ShellExecute(0, "open", "control.exe", "inetcpl.cpl", ".", SW_SHOW);
	}

	// zoom font
	void OnViewFontLargest(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(4L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontLarger(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(3L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontMedium(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(2L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontSmaller(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(1L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}
	void OnViewFontSmallest(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		CComVariant vaZoomFactor(0L);
		T* pT = static_cast<T*>(this);
		pT->m_spBrowser->ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DONTPROMPTUSER,
			&vaZoomFactor, NULL);
	}

	void OnViewSource(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/)
	{
		T* pT = static_cast<T*>(this);
		CComQIPtr<IOleCommandTarget> spCmdTarget = pT->m_spBrowser;
		spCmdTarget->Exec(&CGID_IWebBrowser, HTMLID_VIEWSOURCE, 0, NULL, NULL);
	}
};

template <class T>
class CMDIFrameTitleUpsideDownMessageHandlerWeb
{
public:
	bool m_bValid;
	CString m_strWorkOffline;

	CMDIFrameTitleUpsideDownMessageHandlerWeb() : m_bValid(true), m_strWorkOffline(_T(" - [ItC]"))
	{
	}

	void UpdateTitleBarUpsideDown()
	{
		if (m_bValid) {
			CString strApp; strApp.LoadString(IDR_MAINFRAME);
			T* pT = static_cast<T*>(this);
			pT->SetWindowText(strApp);
		}
	}

	BEGIN_MSG_MAP(CMDIFrameTitleUpsideDownMessageHandlerWeb)
		MESSAGE_HANDLER(WM_GETTEXTLENGTH, OnGetTextLength)
		MESSAGE_HANDLER(WM_GETTEXT, OnGetText)
	END_MSG_MAP()

	LRESULT OnGetTextLength(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		T* pT = static_cast<T*>(this);
		return pT->DefWindowProc(uMsg, wParam, lParam) + m_strWorkOffline.GetLength() + 1;
	}

	LRESULT OnGetText(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		UINT cchTextMax = (UINT)wParam;   // number of characters to copy
		LPTSTR lpszText = (LPTSTR)lParam;

		if (!m_bValid) {
			bHandled = FALSE;
			return 0;
		}

		T* pT = static_cast<T*>(this);

		CString strApp; strApp.LoadString(IDR_MAINFRAME);
		CString strTitle;
		BOOL bMaximized = FALSE;
		HWND hWndActive = pT->MDIGetActive(&bMaximized);
		if (hWndActive == NULL || bMaximized == FALSE)
			strTitle = strApp;
		else
			strTitle = MtlGetWindowText(hWndActive) + _T(" - ") + strApp;

		if (MtlIsGlobalOffline())
			strTitle += m_strWorkOffline;

		::lstrcpyn(lpszText, strTitle, cchTextMax);

		bHandled = TRUE;
		return MtlMin(strTitle.GetLength(), (int)cchTextMax);
	}
};

CString MtlMakeFavoriteToolTipText(const CString& strName_, const CString& strUrl_, int cchTextMax)
{
	CString strName = MtlCompactString(strName_, cchTextMax);

	if (strUrl_.IsEmpty())
		return strName;

	int nCount = cchTextMax - strName.GetLength() - 1;// consider _('\n') too
	if (nCount <= 0)
		return strName;

	CString strUrl;
	bool bRet = MtlCompactPath(strUrl, strUrl_, nCount);

	if (!bRet || strName == strUrl)
		return strName;
	else
		return strName + _T('\n') + strUrl;
}


template <class TKey>
class CSimpleMapInt : public CSimpleMap<TKey, int>
{
public:
	int Lookup(TKey key) const
	{
		int nIndex = FindKey(key);
		if(nIndex == -1)
			return -1;
		return GetValueAt(nIndex);
	}
};

// I thought this is the best, but it seems that
// idls which means the same path don't surely have the same bits.
//typedef CSimpleMapInt< CAdapt<CItemIDList> > CFavoritesOrder;

typedef CSimpleMapInt< CString > CFavoritesOrder;

// Thanks to fub and namazu
typedef struct _tagCFavoritesOrderData
{
	DWORD size;
	DWORD priority;
	ITEMIDLIST idl; // relative idlist
} _CFavoritesOrderData;

// Note. I've found the IE rarely fails to load his own favorites order, but don't care.
// Note. If the item not ordered, priority equals -5.
#define FAVORITESORDER_NOTFOUND -5

void MtlGetFavoritesOrder(CFavoritesOrder& order, const CString& strDirPath)
{
	ATLASSERT(!strDirPath.IsEmpty());
	//+++ const s_unknownOffset = 12;
	const int s_unknownOffset = 12;

	CString strRoot;
	if (!MtlGetFavoritesFolder(strRoot))
		return;
	MtlMakeSureTrailingBackSlash(strRoot);

	CString strKeyName = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites");
	CString strRelative = strDirPath.Right(strDirPath.GetLength() - strRoot.GetLength());
	if (!strRelative.IsEmpty())
		strKeyName += _T('\\') + strRelative;

	MtlRemoveTrailingBackSlash(strKeyName);
//	ATLTRACE(_T(" strKeyName(%s)\n"), strKeyName);

	CRegKey rkOrder;
	LONG lRet = rkOrder.Open(HKEY_CURRENT_USER, strKeyName);
	if (lRet != ERROR_SUCCESS)
		return;

	DWORD dwSize = 0;
	DWORD dwType = REG_BINARY;
	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, NULL, &dwSize);
	if (lRet != ERROR_SUCCESS || dwSize < s_unknownOffset)
		return;

	BYTE* pByte = (BYTE*)_alloca((dwSize+10) * sizeof(BYTE));
	::memset(pByte, 0, dwSize+10);

	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, pByte, &dwSize);
	if (lRet != ERROR_SUCCESS)
		return;

	BYTE* pBegin = pByte + ((_CFavoritesOrderData*)pByte)->size + s_unknownOffset;
	BYTE* pEnd = pByte + dwSize;

	while (pBegin < pEnd) {
		_CFavoritesOrderData* pData = (_CFavoritesOrderData*)pBegin;
		CItemIDList idl(&pData->idl);
		CString strName = MtlGetFileName(idl.GetPath());
		if (!strName.IsEmpty()) {
//			ATLTRACE(_T("order(%s, %d)\n"), strName, pData->priority);
			order.Add(strName, pData->priority);
		}

		pBegin += pData->size;
	}
}
/*
void MtlGetFavoritesOrder(CFavoritesOrder& order, const CString& strDirPath)
{
	ATLASSERT(!strDirPath.IsEmpty());
	const s_unknownOffset = 12;

	CString strRoot;
	if (!MtlGetFavoritesFolder(strRoot))
		return;
	MtlMakeSureTrailingBackSlash(strRoot);

	CString strKeyName = _T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\MenuOrder\\Favorites");
	CString strRelative = strDirPath.Right(strDirPath.GetLength() - strRoot.GetLength());
	if (!strRelative.IsEmpty())
		strKeyName += _T('\\') + strRelative;

	MtlRemoveTrailingBackSlash(strKeyName);
//	ATLTRACE(_T(" strKeyName(%s)\n"), strKeyName);

	CRegKey rkOrder;
	LONG lRet = rkOrder.Open(HKEY_CURRENT_USER, strKeyName);
	if (lRet != ERROR_SUCCESS)
		return;

	DWORD dwSize = 0;
	DWORD dwType = REG_BINARY;
	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, NULL, &dwSize);
	if (lRet != ERROR_SUCCESS || dwSize < s_unknownOffset)
		return;

	BYTE* pByte = (BYTE*)_alloca((dwSize+10) * sizeof(BYTE));
	::memset(pByte, 0, dwSize+10);

	lRet = ::RegQueryValueEx(rkOrder, _T("Order"), NULL, &dwType, pByte, &dwSize);
	if (lRet != ERROR_SUCCESS)
		return;

	BYTE* pBegin = pByte + ((_CFavoritesOrderData*)pByte)->size + s_unknownOffset;
	BYTE* pEnd = pByte + dwSize;

	while (pBegin < pEnd) {
		_CFavoritesOrderData* pData = (_CFavoritesOrderData*)pBegin;
		CItemIDList idl(&pData->idl);
		order.Add(idl, pData->priority);
		pBegin += pData->size;
	}
}
*/

// Based on JOBBY's code
inline DWORD MtlGetInternetZoneActionPolicy(DWORD dwAction)
{
	// create instance IInternetZoneManager
	CComPtr<IInternetZoneManager> spZoneMgr;
	HRESULT hr = CoCreateInstance(CLSID_InternetZoneManager, NULL, CLSCTX_INPROC_SERVER,
		IID_IInternetZoneManager, (void**)&spZoneMgr);

	if (FAILED(hr))
		return false;

	// get security policy
	DWORD dwPolicy = -1;
	hr = spZoneMgr->GetZoneActionPolicy(URLZONE_INTERNET, dwAction,
		(BYTE*)&dwPolicy, sizeof(dwPolicy), URLZONEREG_DEFAULT);

	if (FAILED(hr))
		return false;

	return dwPolicy;
}

inline bool MtlIsInternetZoneActionPolicyDisallow(DWORD dwAction)
{
	if (MtlGetInternetZoneActionPolicy(dwAction) == URLPOLICY_DISALLOW)
		return true;
	else
		return false;
}

bool MtlSetInternetZoneActionPolicy(DWORD dwAction, DWORD dwPolicy)
{
	// create instance IInternetZoneManager
	CComPtr<IInternetZoneManager> spZoneMgr;
	HRESULT hr = CoCreateInstance(CLSID_InternetZoneManager, NULL, CLSCTX_INPROC_SERVER,
		IID_IInternetZoneManager, (void**)&spZoneMgr);

	if (FAILED(hr))
		return false;

	// change security policy
	hr = spZoneMgr->SetZoneActionPolicy(URLZONE_INTERNET,
		dwAction, (BYTE*)&dwPolicy, sizeof(dwPolicy), URLZONEREG_DEFAULT);

	if (FAILED(hr))
		return false;

	// set security level custom
	// now the method is applied
	CVersional<ZONEATTRIBUTES> ZoneAttrib;
	hr = spZoneMgr->GetZoneAttributes(URLZONE_INTERNET, &ZoneAttrib);

	if (FAILED(hr))
		return false;

	ZoneAttrib.dwTemplateCurrentLevel = URLTEMPLATE_CUSTOM;
	hr = spZoneMgr->SetZoneAttributes(URLZONE_INTERNET, &ZoneAttrib);
	if (FAILED(hr))
		return false;

	return true;
}

// not tested yet...
inline bool MtlDeleteAllCookies()
{
	return (::InternetSetOption(0, INTERNET_OPTION_END_BROWSER_SESSION, 0, 0) == TRUE);
}

template <class _Function>
_Function _MtlForEachHTMLDocument2(IHTMLDocument2* pDocument, _Function __f)
{
	__f(pDocument);

	CComPtr<IHTMLFramesCollection2> spFrames;
	HRESULT hr = pDocument->get_frames(&spFrames);
	// cf. Even if no frame, get_frames would succeed.
	if (FAILED(hr)) {
		return __f;
	}

	LONG nCount = 0;
	hr = spFrames->get_length(&nCount);
	if (FAILED(hr))
		return __f;

	for (LONG i = 0; i < nCount; ++i) {
		CComVariant varItem(i);
		CComVariant varResult;
		hr = spFrames->item(&varItem, &varResult);
		if (FAILED(hr))
			continue;

		CComQIPtr<IHTMLWindow2> spWindow = varResult.pdispVal;
		if (!spWindow)
			continue;

		CComPtr<IHTMLDocument2> spDocument;
		hr = spWindow->get_document(&spDocument);
		if (FAILED(hr))
			continue;

		_MtlForEachHTMLDocument2(spDocument, __f);
	}

	return __f;
}

template <class _Function>
_Function MtlForEachHTMLDocument2(IWebBrowser2* pBrowser, _Function __f)
{
	CComPtr<IDispatch> spDisp;
	HRESULT hr = pBrowser->get_Document(&spDisp);
	if (FAILED(hr))
		return __f;

	CComQIPtr<IHTMLDocument2> spDocument = spDisp;
	if (!spDocument)
		return __f;

	return _MtlForEachHTMLDocument2(spDocument, __f);
}


bool __MtlSkipChar(const CString& str, int& nIndex, TCHAR ch)
{
	ATLASSERT(nIndex < str.GetLength());

	if (str[nIndex] == ch)
		++nIndex;

	if (nIndex >= str.GetLength())
		return false;
	else
		return true;
}

void _MtlCreateHrefUrlArray(CSimpleArray<CString>& arrUrl, const CString& strHtmlText)
{
	int nLast = -1;
	int nFirst = 0;
	int nLen = strHtmlText.GetLength();

	while (nFirst != -1 && nFirst < nLen)
	{
		nFirst = __MtlFind(strHtmlText, nFirst, _T("href"));
		nFirst += 4;
		if (nFirst >= nLen)
			break;

		if (!__MtlSkipChar(strHtmlText, nFirst, _T(' ')))
			break;


		if (strHtmlText[nFirst] == _T('=')) // skip a '='
			++nFirst;
		else
			break;							// illegal

		if (nFirst >= nLen)
			break;


		if (!__MtlSkipChar(strHtmlText, nFirst, _T(' ')))
			break;

		if (strHtmlText[nFirst] == _T('\"')) {	// if "
			++nFirst;
			nLast = __MtlFindChar(strHtmlText, nFirst, _T('\"'));
			if (nLast == -1)
				break;							// illegal

			CString str = strHtmlText.Mid(nFirst, nLast - nFirst);
			arrUrl.Add(str);
		}
		else {
			nLast = __MtlFindChar(strHtmlText, nFirst, _T(' '));// first, find a space
			if (nLast != -1) {
				CString str = strHtmlText.Mid(nFirst, nLast - nFirst);
				arrUrl.Add(str);
			}
			else {
				nLast = __MtlFindChar(strHtmlText, nFirst, _T('>'));// second, find a '>'
				if (nLast != -1) {
					CString str = strHtmlText.Mid(nFirst, nLast - nFirst);
					arrUrl.Add(str);
				}
				else {							// illegal
					break;
				}
			}
		}

		nFirst = nLast;
	}

}

inline CString _MtlGetDirectoryPathFixed(const CString& strPath, bool bAddBackSlash = false)
{
	bool bSlash = false;
	int nIndex = strPath.ReverseFind(_T('\\'));// first

	if (nIndex == -1) {
		nIndex = strPath.ReverseFind(_T('/'));
		bSlash = true;
	}

	CString strRet = strPath.Left(nIndex);

	if (bAddBackSlash) {
		if (bSlash)
			MtlMakeSureTrailingChar(strRet, _T('/'));
		else
			MtlMakeSureTrailingChar(strRet, _T('\\'));
	}

	return strRet;
}

inline CString _MtlGetRootDirectoryPathFixed(const CString& strPath, bool bAddBackSlash = false)
{
	bool bSlash = false;

	int nIndex = strPath.Find(_T(":\\"));	// first
	if (nIndex != -1) {
		nIndex += 2;
	}
	else {									// second
		nIndex = strPath.Find(_T("://"));
		bSlash = true;
		if (nIndex != -1)
			nIndex += 3;
	}

	TCHAR chSep;
	if (bSlash)
		chSep = _T('/');
	else
		chSep = _T('\\');

	if (nIndex > 0)
		nIndex = __MtlFindChar(strPath, nIndex, chSep);

	if (nIndex == -1) {// if not found, whole string is the root path.
		nIndex = strPath.GetLength();
	}

	CString strRet = strPath.Left(nIndex);

	if (bAddBackSlash) {
		MtlMakeSureTrailingChar(strRet, chSep);
	}

	return strRet;
}

inline bool _MtlIsIllegalRootSlash(const CString& str)
{
	if (str.GetLength() < 1)
		return false;

	if (str[0] == _T('/') || str[0] == _T('\\'))
		return true;
	else
		return false;
}

inline bool _MtlIsMailTo(const CString& str)
{
	if (str.Left(7) == _T("mailto:"))
		return true;
	else
		return false;
}

inline bool _MtlIsHrefID(const CString& str)
{
	if (str.GetLength() < 1)
		return false;

	if (str[0] == _T('#'))
		return true;
	else
		return false;
}

inline CString _MtlRemoveIDFromUrl(const CString& str)
{
	int nIndex = str.ReverseFind(_T('#'));
	if (nIndex != -1)
		return str.Left(nIndex);
	else
		return str;
}

inline bool _MtlIsRelativePath(const CString& str)
{
	return (str.Find(_T("://")) == -1) && (str.Find(_T(":\\")) == -1) && !_MtlIsMailTo(str);
}

inline void MtlCreateHrefUrlArray(CSimpleArray<CString>& arrUrl,
						   const CString& strHtmlText, const CString& strLocationUrl)
{
	CSimpleArray<CString> _arrUrl;
	_MtlCreateHrefUrlArray(_arrUrl, strHtmlText);

	CString strDirectory = _MtlGetDirectoryPathFixed(strLocationUrl, true);
	CString strRoot = _MtlGetRootDirectoryPathFixed(strLocationUrl, true);

	for (int i = 0; i < _arrUrl.GetSize(); ++i)
	{
		CString strUrl = _arrUrl[i];

		if (_MtlIsHrefID(strUrl))
		{// href = #xxx
			strUrl = _MtlRemoveIDFromUrl(strLocationUrl) + strUrl;
		}
		else if (_MtlIsRelativePath(strUrl))
		{// maybe relative path
			if (strUrl.Left(3) == _T("../")) {			// root
				strUrl = strRoot + strUrl.Right(strUrl.GetLength() - 3);
			}
			else if (_MtlIsIllegalRootSlash(strUrl)) {	// root, but illegal.
				strUrl = strRoot + strUrl.Right(strUrl.GetLength() - 1);
			}
			else {
				strUrl = strDirectory + strUrl;
			}
		}

		strUrl.Replace(_T("&amp;") , _T("&")); // Replace &amp;
		strUrl.Replace(_T('\\'), _T('/'));
		arrUrl.Add(strUrl);
	}
}


}  //namespace MTL

#endif // __MTLWEB_H__